/*
(c) Janusz Ganczarski
http://www.januszg.hg.pl
JanuszG@enter.net.pl
*/

#include <GL/glut.h>
#include <stdlib.h>

// stae do obsugi menu podrcznego

enum
{
    BITMAP_9_BY_15,         // czcionka GLUT_BITMAP_9_BY_15
    BITMAP_8_BY_13,         // czcionka GLUT_BITMAP_8_BY_13
    BITMAP_TIMES_ROMAN_10,  // czcionka GLUT_BITMAP_TIMES_ROMAN_10
    BITMAP_TIMES_ROMAN_24,  // czcionka GLUT_BITMAP_TIMES_ROMAN_24
    BITMAP_HELVETICA_10,    // czcionka GLUT_BITMAP_HELVETICA_10
    BITMAP_HELVETICA_12,    // czcionka GLUT_BITMAP_HELVETICA_12
    BITMAP_HELVETICA_18,    // czcionka GLUT_BITMAP_HELVETICA_18
    EXIT                    // wyjcie
};

// wybrana czcionka - pocztkowo brak czcionki

void *font = NULL;

// funkcja generujca scen 3D

void DisplayScene ()
{
    // kolor ta - zawarto bufora koloru
    glClearColor (1.0,1.0,1.0,1.0);

    // czyszczenie bufora koloru
    glClear (GL_COLOR_BUFFER_BIT);

    // kolor wywietlanych napisw
    glColor3f (0.0,0.0,0.0);

    // numer wywietlanego znaku ASCII
    int character = 32;

    // rysowanie poszczeglnych wierszy ze znakami (po 32 znaki w wierszu)
    if (font != NULL)
        for (int row = 0; row < 7; row++)
        {
            // pooenie napisu
            glRasterPos2f (1,24*row+1);

            // wywietlenie znakw
            for (int i = 0; i < 32; i++)
                glutBitmapCharacter (font,character++);
        }

    // skierowanie polece do wykonania
    glFlush ();

    // zamiana buforw koloru
    glutSwapBuffers();
}

// zmiana wielkoci okna

void Reshape (int width, int height)
{
    // obszar renderingu - cae okno
    glViewport (0,0,width,height);

    // wybr macierzy rzutowania
    glMatrixMode (GL_PROJECTION);

    // macierz rzutowania = macierz jednostkowa
    glLoadIdentity ();

    // rzutowanie prostoktne
    gluOrtho2D (0,width-1,0,height-1);

    // generowanie sceny 3D
    DisplayScene ();
}

// obsuga menu podrcznego

void Menu (int value)
{
    switch (value)
    {
        // czcionka GLUT_BITMAP_9_BY_15
        case BITMAP_9_BY_15:
        font = GLUT_BITMAP_9_BY_15;
        glutSetWindowTitle ("Czcionki bitmapowe - GLUT_BITMAP_9_BY_15");
        DisplayScene ();
        break;

        // czcionka GLUT_BITMAP_8_BY_13
        case BITMAP_8_BY_13:
        font = GLUT_BITMAP_8_BY_13;
        glutSetWindowTitle ("Czcionki bitmapowe - GLUT_BITMAP_8_BY_13");
        DisplayScene ();
        break;

        // czcionka GLUT_BITMAP_TIMES_ROMAN_10
        case BITMAP_TIMES_ROMAN_10:
        font = GLUT_BITMAP_TIMES_ROMAN_10;
        glutSetWindowTitle ("Czcionki bitmapowe - GLUT_BITMAP_TIMES_ROMAN_10");
        DisplayScene ();
        break;

        // czcionka GLUT_BITMAP_TIMES_ROMAN_24
        case BITMAP_TIMES_ROMAN_24:
        font = GLUT_BITMAP_TIMES_ROMAN_24;
        glutSetWindowTitle ("Czcionki bitmapowe - GLUT_BITMAP_TIMES_ROMAN_24");
        DisplayScene ();
        break;

        // czcionka GLUT_BITMAP_HELVETICA_10
        case BITMAP_HELVETICA_10:
        font = GLUT_BITMAP_HELVETICA_10;
        glutSetWindowTitle ("Czcionki bitmapowe - GLUT_BITMAP_HELVETICA_10");
        DisplayScene ();
        break;

        // czcionka GLUT_BITMAP_HELVETICA_12
        case BITMAP_HELVETICA_12:
        font = GLUT_BITMAP_HELVETICA_12;
        glutSetWindowTitle ("Czcionki bitmapowe - GLUT_BITMAP_HELVETICA_12");
        DisplayScene ();
        break;

        // czcionka GLUT_BITMAP_HELVETICA_18
        case BITMAP_HELVETICA_18:
        font = GLUT_BITMAP_HELVETICA_18;
        glutSetWindowTitle ("Czcionki bitmapowe - GLUT_BITMAP_HELVETICA_18");
        DisplayScene ();
        break;

        // wyjcie
        case EXIT:
        exit (0);
    }
}

int main (int argc, char *argv[])
{
    // inicjalizacja biblioteki GLUT
    glutInit (&argc,argv);

    // inicjalizacja bufora ramki
    glutInitDisplayMode (GLUT_DOUBLE|GLUT_RGB);

    // rozmiary gwnego okna programu
    glutInitWindowSize (550,200);

    // utworzenie gwnego okna programu
    glutCreateWindow ("Czcionki bitmapowe");

    // doczenie funkcji generujcej scen 3D
    glutDisplayFunc (DisplayScene);

    // doczenie funkcji wywoywanej przy zmianie rozmiaru okna
    glutReshapeFunc (Reshape);

    // utworzenie podmenu - czcionka
    int MenuFont = glutCreateMenu (Menu);
    glutAddMenuEntry ("GLUT_BITMAP_9_BY_15",BITMAP_9_BY_15);
    glutAddMenuEntry ("GLUT_BITMAP_8_BY_13",BITMAP_8_BY_13);
    glutAddMenuEntry ("GLUT_BITMAP_TIMES_ROMAN_10",BITMAP_TIMES_ROMAN_10);
    glutAddMenuEntry ("GLUT_BITMAP_TIMES_ROMAN_24",BITMAP_TIMES_ROMAN_24);
    glutAddMenuEntry ("GLUT_BITMAP_HELVETICA_10",BITMAP_HELVETICA_10);
    glutAddMenuEntry ("GLUT_BITMAP_HELVETICA_12",BITMAP_HELVETICA_12);
    glutAddMenuEntry ("GLUT_BITMAP_HELVETICA_18",BITMAP_HELVETICA_18);

    // menu gwne
    glutCreateMenu (Menu);
    glutAddSubMenu ("Czcionka",MenuFont);
#ifdef WIN32

    glutAddMenuEntry ("Wyjcie",EXIT);
#else

    glutAddMenuEntry ("Wyjscie",EXIT);
#endif

    // okrelenie przycisku myszki obsugujcego menu podrczne
    glutAttachMenu (GLUT_RIGHT_BUTTON);

    // wprowadzenie programu do obsugi ptli komunikatw
    glutMainLoop ();
    return 0;
}
