/*
(c) Janusz Ganczarski
http://www.januszg.hg.pl
JanuszG@enter.net.pl
*/

#include <GL/glut.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

// stae do obsugi menu podrcznego

enum
{
    EXIT                    // wyjcie
};

// wywietlany cig znakw

char string [100] = "";

// funkcja generujca scen 3D

void DisplayScene ()
{
    // kolor ta - zawarto bufora koloru
    glClearColor (1.0,1.0,1.0,1.0);

    // czyszczenie bufora koloru
    glClear (GL_COLOR_BUFFER_BIT);

    // kolor wywietlanych napisw
    glColor3f (1.0,0.0,0.0);

    // pooenie napisu
    glRasterPos2f (-0.5,0.0);

    // wywietlenie napisu
    int len = strlen (string);
    for (int i = 0; i < len; i++)
        glutBitmapCharacter (GLUT_BITMAP_TIMES_ROMAN_24,string [i]);

    // skierowanie polece do wykonania
    glFlush ();

    // zamiana buforw koloru
    glutSwapBuffers ();
}

// zmiana wielkoci okna

void Reshape (int Width,int Height)
{
    // obszar renderingu - cae okno
    glViewport (0,0,Width,Height);

    // wybr macierzy rzutowania
    glMatrixMode (GL_PROJECTION);

    // macierz rzutowania = macierz jednostkowa
    glLoadIdentity ();

    // rzutowanie prostoktne
    glOrtho (-1.0,1.0,-1.0,1.0,-1.0,1.0);

    // wywietlenie okna
    DisplayScene ();
}

// obsuga klawiatury

void Keyboard (unsigned char key, int x, int y)
{
    // pobranie stanu przyciskw Shift, Ctrl i Alt
    int mod = glutGetModifiers ();

    switch (key)
    {
        // przycisk Tab
        case '\t':
        strcpy (string,"Tab");
        break;

        // przycisk Backspace
        case '\b':
        strcpy (string,"Backspace");
        break;

        // przycisk Enter
        case '\r':
        strcpy (string,"Enter");
        break;

        // przycisk Delete
        case 127:
        strcpy (string,"Delete");
        break;

        // przycisk Space
        case 32:
        strcpy (string,"Space");
        break;

        // pozostae przyciski
        default:
        string [0] = key;
        string [1] = '\0';
        break;
    }

    // obsuga przyciskw Shift, Ctrl i Alt
    if (mod & GLUT_ACTIVE_SHIFT)
        strcat (string,"+Shift");
    if (mod & GLUT_ACTIVE_CTRL)
        strcat (string,"+Ctrl");
    if (mod & GLUT_ACTIVE_ALT)
        strcat (string,"+Alt");

    // odrysowanie okna
    DisplayScene ();
}

// obsuga klawiatury - zwolnienie przycisku

void KeyboardUp (unsigned char key, int x, int y)
{
    // wyzerowanie cigu znakw
    string [0] = '\0';

    // odrysowanie okna
    DisplayScene ();
}

// obsuga klawiszy funkcyjnych i klawiszy kursora

void SpecialKeys (int key, int x, int y)
{
    // pobranie stanu przyciskw Shift, Ctrl i Alt
    int mod = glutGetModifiers ();

    switch (key)
    {
        // kursor w lewo
        case GLUT_KEY_LEFT:
        strcpy (string,"Left arrow");
        break;

        // kursor w gr
        case GLUT_KEY_UP:
        strcpy (string,"Up arrow");
        break;

        // kursor w prawo
        case GLUT_KEY_RIGHT:
        strcpy (string,"Right arrow");
        break;

        // kursor w d
        case GLUT_KEY_DOWN:
        strcpy (string,"Down arrow");
        break;

        // przycisk Page Up
        case GLUT_KEY_PAGE_UP:
        strcpy (string,"Page Up");
        break;

        // przycisk Page Down
        case GLUT_KEY_PAGE_DOWN:
        strcpy (string,"Page Down");
        break;

        // przycisk Home
        case GLUT_KEY_HOME:
        strcpy (string,"Home");
        break;

        // przycisk End
        case GLUT_KEY_END:
        strcpy (string,"End");
        break;

        // przycisk Insert
        case GLUT_KEY_INSERT:
        strcpy (string,"Insert");
        break;

        // przycisk F1
        case GLUT_KEY_F1:
        strcpy (string,"F1");
        break;

        // przycisk F2
        case GLUT_KEY_F2:
        strcpy (string,"F2");
        break;

        // przycisk F3
        case GLUT_KEY_F3:
        strcpy (string,"F3");
        break;

        // przycisk F4
        case GLUT_KEY_F4:
        strcpy (string,"F4");
        break;

        // przycisk F5
        case GLUT_KEY_F5:
        strcpy (string,"F5");
        break;

        // przycisk F6
        case GLUT_KEY_F6:
        strcpy (string,"F6");
        break;

        // przycisk F7
        case GLUT_KEY_F7:
        strcpy (string,"F7");
        break;

        // przycisk F8
        case GLUT_KEY_F8:
        strcpy (string,"F8");
        break;

        // przycisk F9
        case GLUT_KEY_F9:
        strcpy (string,"F9");
        break;

        // przycisk F10
        case GLUT_KEY_F10:
        strcpy (string,"F10");
        break;

        // przycisk F11
        case GLUT_KEY_F11:
        strcpy (string,"F11");
        break;

        // przycisk F12
        case GLUT_KEY_F12:
        strcpy (string,"F12");
        break;
    }

    // obsuga przyciskw Shift, Ctrl i Alt
    if (mod & GLUT_ACTIVE_SHIFT)
        strcat (string,"+Shift");
    if (mod & GLUT_ACTIVE_CTRL)
        strcat (string,"+Ctrl");
    if (mod & GLUT_ACTIVE_ALT)
        strcat (string,"+Alt");

    // odrysowanie okna
    DisplayScene ();
}

// obsuga klawiszy funkcyjnych i klawiszy kursora - zwolnienie przycisku

void SpecialUpKeys (int key, int x, int y)
{
    // wyzerowanie cigu znakw
    string [0] = '\0';

    // odrysowanie okna
    DisplayScene ();
}

// obsuga menu podrcznego

void Menu (int value)
{
    if (value == EXIT)
        exit (0);
}

int main (int argc, char *argv[])
{
    // inicjalizacja biblioteki GLUT
    glutInit (&argc,argv);

    // inicjalizacja bufora ramki
    glutInitDisplayMode (GLUT_DOUBLE|GLUT_RGB);

    // rozmiary gwnego okna programu
    glutInitWindowSize (400,150);

    // utworzenie gwnego okna programu
    glutCreateWindow ("Klawiatura");

    // doczenie funkcji generujcej scen 3D
    glutDisplayFunc (DisplayScene);

    // doczenie funkcji wywoywanej przy zmianie rozmiaru okna
    glutReshapeFunc (Reshape);

    // doczenie funkcji obsugi klawiatury
    glutKeyboardFunc (Keyboard);

    // doczenie funkcji obsugi klawiatury - zwolnienie przycisku
    glutKeyboardUpFunc (KeyboardUp);

    // doczenie funkcji obsugi klawiszy funkcyjnych i klawiszy kursora
    glutSpecialFunc (SpecialKeys);

    // doczenie funkcji obsugi klawiszy funkcyjnych
    // i klawiszy kursora - zwolnienie przycisku
    glutSpecialUpFunc (SpecialUpKeys);

    // menu gwne
    glutCreateMenu (Menu);
#ifdef WIN32

    glutAddMenuEntry ("Wyjcie",EXIT);
#else

    glutAddMenuEntry ("Wyjscie",EXIT);
#endif

    // okrelenie przycisku myszki obsugujcego menu podrczne
    glutAttachMenu (GLUT_RIGHT_BUTTON);

    // wprowadzenie programu do obsugi ptli komunikatw
    glutMainLoop ();
    return 0;
}
